"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelPluginTsconfigPathsModuleResolver = babelPluginTsconfigPathsModuleResolver;

var _babelPluginModuleResolver = _interopRequireDefault(require("babel-plugin-module-resolver"));

var _defaultExtensions = require("./default-extensions");

var _createResolvePath = require("./create-resolve-path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function babelPluginTsconfigPathsModuleResolver(...args) {
  const result = (0, _babelPluginModuleResolver.default)(...args);

  function mutateThis(incomingThis) {
    const opts = incomingThis.opts = incomingThis.opts || {};
    opts.extensions = opts.extensions || _defaultExtensions.defaultExtensions;
    opts.resolvePath = opts.resolvePath || (0, _createResolvePath.createResolvePath)();
  }

  return { ...result,
    name: 'tsconfig-paths-module-resolver',
    ...((result === null || result === void 0 ? void 0 : result.manipulateOptions) && {
      manipulateOptions(...args) {
        var _result$manipulateOpt;

        mutateThis(this);
        return (_result$manipulateOpt = result.manipulateOptions) === null || _result$manipulateOpt === void 0 ? void 0 : _result$manipulateOpt.call(this, ...args);
      }

    }),
    ...((result === null || result === void 0 ? void 0 : result.pre) && {
      pre(...args) {
        var _result$pre;

        mutateThis(this);
        return (_result$pre = result.pre) === null || _result$pre === void 0 ? void 0 : _result$pre.call(this, ...args);
      }

    })
  };
}

babelPluginTsconfigPathsModuleResolver.createResolvePath = _createResolvePath.createResolvePath;